//-----------------------------------------------------------------------
// \ : lin_slave_example.c
//-----------------------------------------------------------------------

//----- ݸٰ
#include "config.h"
#include "lin_drv.h"

//----- 錾
#define LIN_ID_0		0x12
#define LIN_ID_1		0x13

#define LEN_0			1
#define LEN_1			2

unsigned char lin_motor_contol[LEN_0];
unsigned char lin_node_status[LEN_1];

volatile unsigned char lin_slave_err_nb = 0;

//----- ֐ ------------------------------------------------------------

//.......................................................................
// "lin_slave_example.c"lin_id_task֐
//
//	MLIN ID͌Aߓ_(ɰ)ǗȂ΂ȂȂ̂Ɣr
//	Ȃ΂Ȃ܂B
//.......................................................................
void lin_id_task (void)
{
	switch (Lin_get_id())
	{
		case LIN_ID_0:
			lin_rx_response(LIN_2X, LEN_0);
			break;
		case LIN_ID_1:
			lin_tx_response(LIN_2X, lin_node_status, LEN_1);
			break;
		default:
			// ID:s/
			break;
	}
}

//.......................................................................
// "lin_slave_example.c"lin_rx_task֐
//
//	- ްۑ
//	- pMXV
//.......................................................................
void lin_rx_task (void)
{
	unsigned char l_temp;

	lin_get_response (lin_motor_contol);

	// pM̍XV
	l_temp = lin_motor_contol[0] & 0x03;
	if((l_temp == 0x01) || (l_temp == 0x03))
	{
		PORTB |= 1<<PORT0;
	}
	else
	{
		PORTB &= ~(1<<PORT0);
	}
	if(l_temp == 0x02)
	{
		PORTB |= 1<<PORT1;
	}
	else
	{
		PORTB &= ~(1<<PORT1);
	}
}

//.......................................................................
// "lin_slave_example.c"lin_tx_task֐
//
//	- ̑M𐮂邽߂ɉpMŊɏՕzXV
//.......................................................................
void lin_tx_task (void)
{
	// pM̍XV
	lin_node_status[0] = PINB & 0x03;
	lin_node_status[1] = lin_slave_err_nb;
}

//.......................................................................
// "lin_slave_example.c"lin_err_task֐
//
//	- LINُȂAߓ_(ɰ)ُԍ𑝉
//.......................................................................
void lin_err_task (void)
{
	// SϐXV
	lin_slave_err_nb++;
}

//.......................................................................
//. . . m a i n ( )
//
// "lin_slave_example.c"mian֐
//
//	'I薳'ňȉsAJԂ܂B
//		- LIN_ID_0(M1޲)ȂA
//			EPORT-B.0 = DCd@߁ˎv
//			EPORT-B.1 = DCd@߁˔v
// 		- LIN_ID_1(M2޲)ȂA
//			EByte[0] = d@
//			EByte[1] = ߓ_(ɰ)ُԍ
//.......................................................................
int main (void)
{
	// d@p߰Bݒ
	DDRB |= 1<<PORTB0; DDRB |= 1<<PORTB1;
	PORTB &= ~(1<<PORTB0); PORTB &= ~(1<<PORTB1);

	// LIN
	lin_init((unsigned char)LIN_2X, ((unsigned short)CONF_LINBRR));

	// I薳JԂ
	while (1)
	{
		switch (Lin_get_it())
		{
			case LIN_IDOK:
				lin_id_task();
				Lin_clear_idok_it();
				break;
			case LIN_RXOK:
				lin_rx_task();
				Lin_clear_rxok_it();
				break;
			case LIN_TXOK:
				lin_tx_task();
				Lin_clear_txok_it();
				break;
			case LIN_ERROR:
				lin_err_task();
				Lin_clear_err_it();
				break;
			default:
				break;
		}
	}
	return 0;
}
